Bug 174818 - [PATCH] bonding: don't drop non-VLAN traffic
[PATCH] bonding: don't drop non-VLAN traffic
Status: CLOSED ERRATA
Product: Red Hat Enterprise Linux 3
Classification: Red Hat
Component: kernel (Show other bugs)
3.0
All Linux
medium Severity medium
: ---
: ---
Assigned To: John W. Linville
Brian Brock
http://marc.theaimsgroup.com/?l=linux...
:
Depends On:
Blocks: RHEL3U8CanFix
  Show dependency treegraph
 
Reported: 2005-12-02 10:03 EST by John W. Linville
Modified: 2007-11-30 17:07 EST (History)
3 users (show)

See Also:
Fixed In Version: RHSA-2006-0437
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2006-07-20 09:36:45 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)

  None (edit)
Description John W. Linville 2005-12-02 10:03:23 EST
+++ This bug was initially created as a clone of Bug #174671 +++

Note:  This bug appeared in Fedora Legacy for FC2.  This is apparently still
a problem in the 2.6 kernel for RHEL 4.  See Roland Pope's comment of 2005-
11-28, below.

Hope this helps.  -David

+++ This bug was initially created as a clone of Bug #162208 +++

From Bugzilla Helper:
User-Agent: Mozilla/5.0 (Windows; U; Windows NT 5.1; en-US; rv:1.7.8)
Gecko/20050511 Firefox/1.0.4

Description of problem:
Patch for the bonding driver that was released after FC2 went legacy.  The
problem was when the system had an IP it was using on its bond0 interface and an
IP configured on a VLAN interface, the bond0 IP stopped working.

This is a patch submitted to netdev by Jay Vosburgh:
  Change the bonding driver to not drop non-VLAN traffic when a
  VLAN is configured above it.  Originally fixed by Olaf Kirch
  <okir@suse.de>; I changed his patch slightly to update comments.

Version-Release number of selected component (if applicable):


How reproducible:
Always

Steps to Reproduce:
1. Bring up a bonded interface
2. Assign an IP address to bond0, e.g. 192.168.3.5
3. Assign an IP address on a VLAN on bond0.XXX, e.g. 192.168.8.5
  

Actual Results:  The IP address on bond0 (192.168.3.5) would stop working when
the bond0.XXX interface was brought up.

Expected Results:  Configured IP addresses on both bond0 and bond0.XXX should
have coexisted peacefully.

Additional info:

Jay's post of the patch to the netdev list:
http://marc.theaimsgroup.com/?l=linux-netdev&m=111230077422086&w=2

-- Additional comment from bwann@wann.net on 2005-06-30 16:42 EST --
Created an attachment (id=116185)
Jay Vosburgh/Olaf Kirch's "don't drop non-VLAN traffic" patch


-- Additional comment from marcdeslauriers@videotron.ca on 2005-07-30 20:23 EST --
Did this make it into a more recent upstream kernel?

<snip Fedora Legacy status change post by Pekka Savola>

-- Additional comment from rpope@jadeworld.com on 2005-11-28 21:42 EST --
Any reason why this fix hasn't made it into the kernel yet? Especially Given 
the length of time this BUG has been open and triviality of the patch? I 
personally found this problem wasted a large amount of my time under RedHat 
Enterprise 4 as it broke a machine that was working with VLAN's under a bonding 
interface under Enterprise 3 and there was no obvious reason as no errors were 
logged and the bonded interface just ate non VLAN packets.
Shouldn't this BUG be logged against RedHat Enterprise 4 as maybe it would get 
a little more priority?

<snip duplicate post from Roland Pope>
<snip Fedora-Legacy response post by Pekka Savola>

-- Additional comment from linville@redhat.com on 2005-12-01 17:34 EST --
Created an attachment (id=121717)
jwltest-bonding-vlan.patch


-- Additional comment from linville@redhat.com on 2005-12-01 17:38 EST --
Test kernels w/ above patch are available here: 
 
   http://people.redhat.com/linville/kernels/rhel4/ 
 
Please verify that they work as expected, and post the results here...thanks! 

-- Additional comment from rpope@jadeworld.com on 2005-12-01 18:55 EST --
Using this kernel, I can now configure an IP address onto the BONDx interface 
and it continues to work after bringing up a BONDx.nnnn VLAN Interface. Prior 
to this patch, the BOND0 Interface stopped transmitting packets as soon as the 
first VLAN sub Interface was activated.
In addition to this, it appears I lied when I said this was working on RedHat 
Enterprise 3 Update 6 (I thought from memory it work, but alas...no). I have 
gone back and tested this again under the 2.4.21-37.EL kernel and it behaves 
the same as the Unpatched Enterprise 4 kernel. As soon as you bringup the first 
VLAN interface on a bonded device, you loose the ability to transmit no VLAN 
packets.
So would it also be possible to get this patch added to the Enterprise 3 
Kernels too?
Comment 1 John W. Linville 2005-12-05 10:32:12 EST
Roland, RHEL3 test kernels are available here: 
 
   http://people.redhat.com/linville/kernels/rhel3/ 
 
Please give those a try to verify that they work as expected...thanks! 
Comment 2 Roland Pope 2005-12-05 18:21:18 EST
Yes, this kernel allows me to bringup a VLAN on a bonded interface without 
losing the ability to transmit non-VLANed packets. Thanks.
Comment 4 Ernie Petrides 2006-02-23 22:45:47 EST
A fix for this problem has just been committed to the RHEL3 U8
patch pool this evening (in kernel version 2.4.21-40.3.EL).
Comment 8 Red Hat Bugzilla 2006-07-20 09:36:46 EDT
An advisory has been issued which should help the problem
described in this bug report. This report is therefore being
closed with a resolution of ERRATA. For more information
on the solution and/or where to find the updated files,
please follow the link below. You may reopen this bug report
if the solution does not work for you.

http://rhn.redhat.com/errata/RHSA-2006-0437.html

Note You need to log in before you can comment on or make changes to this bug.